#!/bin/sh
if [ "$1" != "--no-depend" ]; then
  sudo apt-get install -y --no-install-recommends libluajit-5.1
fi
if [ -e /usr/local/games/love ]; then
  sudo rm -rf /usr/local/games/love.orig
  sudo mv -f /usr/local/games/love /usr/local/games/love.orig
fi
if [ -e /usr/bin/love -a ! -L /usr/bin/love ]; then
  sudo rm -rf /usr/bin/love.orig
  sudo mv -f /usr/bin/love /usr/bin/love.orig
fi
LOVE=love.$$
cat <<'EOF11' >$LOVE
#!/bin/sh
export LD_LIBRARY_PATH=/usr/local/games/love/lib
/usr/local/games/love/bin/love "$@"
EOF11
sudo mv $LOVE /usr/bin/love
sudo chmod +x /usr/bin/love

sudo cp -r love /usr/local/games

cp /usr/local/games/love/share/applications/love.desktop ~/Desktop
lua update_geany.lua
echo "Updating MIME database..."
sudo mkdir -p /usr/local/share/mime/packages
sudo cp -f /usr/local/games/love/share/mime/packages/love.xml /usr/local/share/mime/packages/
sudo update-mime-database /usr/local/share/mime
echo "Registering icons..."
xdg-icon-resource install --novendor --context apps --size 48 /usr/local/games/love/share/icons/hicolor/48x48/apps/love.png
xdg-icon-resource install --novendor --context mimetypes --size 48 /usr/local/games/love/share/icons/hicolor/48x48/mimetypes/application-x-love-game.png
echo "Updating desktop database..."
sudo mkdir -p /usr/local/share/applications
sudo cp -f /usr/local/games/love/share/applications/love.desktop /usr/local/share/applications/
sudo update-desktop-database /usr/local/share/applications/
