#!/usr/bin/lua
d = os.getenv("HOME") .. "/.config/geany/filedefs"
if os.execute("ls >/dev/null 2>&1") ~= 0 then os.exit(0) end
a = {}
b = nil
c = nil
f = d .. "/filetypes.lua"
install = true
if arg[1] == "--uninstall" then
  install = false
end
file = io.open(f, "r")
if file then
  for s in file:lines() do
    if b == nil then
      if s == "[build-menu]" then
        b = {}
      else
        table.insert(a, s)
      end
    elseif c == nil then
      local n, lbl, cont = s:match("^EX_(%d%d)_([^=]*)=(.*)$")
      if n ~= nil then
        n = tonumber(n)
        b[n] = b[n] or {}
        b[n][lbl] = cont
      else
        c = {s}
      end
    else
      table.insert(c, s)
    end
  end
end
love_index = nil
if b then
  for i, t in ipairs(b) do
    if t["LB"] == "Execute with LÖVE" or t["LB"] == "LÖVE で実行" then
      love_index = i
    end
  end
end
if install then
  if love_index == nil then
    if b == nil then b = {} end
    love_index = #b + 1
  end
  b[love_index] = b[love_index] or {}
  local lang = os.getenv("LANG")
  local lbl
  if lang and lang:match("^ja_JP") then
    lbl = "LÖVE で実行"
  else
    lbl = "Execute with LÖVE"
  end
  b[love_index]["LB"] = lbl
  b[love_index]["CM"] = 'love "%f"'
  b[love_index]["WD"] = ""
else
  if love_index == nil then os.exit(0) end
  table.remove(b, love_index)
end
file = io.open(f, "w")
if not file then
  io.stderr:write("Cannot open " .. f .. " for output\n")
  os.exit(1)
end
if a then
  for i = 1, #a do file:write(a[i] .. "\n") end
end
if b and #b > 0 then
  file:write("[build-menu]\n")
  for i = 1, #b do
    file:write(string.format("EX_%02d_LB=%s\n", i, b[i]["LB"]))
    file:write(string.format("EX_%02d_CM=%s\n", i, b[i]["CM"]))
    file:write(string.format("EX_%02d_WD=%s\n", i, b[i]["WD"]))
  end
end
if c then
  for i = 1, #c do file:write(c[i] .. "\n") end
end
file:close()
if not ((a and #a > 0) or (b and #b > 0) or (c and #c > 0)) then
  os.remove(f)
end
